`timescale 1ns/1ns

module fpga_top_sim ();

	parameter cycle = 20;
	parameter half  = 10;

	reg				CLOCK_50;
	reg				CLR;
	reg				BUTTON;
	wire	[3:0]	LED;
	wire	[31:0]	moni = u1.inst2.cnt_out;
	
	fpga_top u1 (
		.clock_50	(CLOCK_50),
		.clr		(CLR),
		.button		(BUTTON),
		.led		(LED)
		);
	
	initial begin
		CLOCK_50 <= 1'b0;
		CLR <= 1'b1;
		BUTTON <= 1'b1;		
		#(115000)
		CLR <= 1'b0;
		#(cycle * 30000)
		CLR <= 1'b1;		
		#(cycle * 10000000)
		BUTTON <= 1'b0;
		#(cycle * 5000000)
		BUTTON <= 1'b1;
	end
	
	always begin
		#(half) CLOCK_50 <= ~CLOCK_50;
	end
endmodule
