LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY chatt IS
	PORT (
		clk		:	IN STD_LOGIC;
		clr_n	:	IN STD_LOGIC;
		button	:	IN STD_LOGIC;
		sw_out	:	OUT STD_LOGIC
	);
END chatt;

ARCHITECTURE rtl OF chatt IS

	SIGNAL	time_cnt	:	STD_LOGIC_VECTOR (19 DOWNTO 0):= (OTHERS => '0');
	SIGNAL	sht_reg		:	STD_LOGIC_VECTOR (3 DOWNTO 0):= (OTHERS => '0');
	SIGNAL	sw_reg		:	STD_LOGIC:= '0';

BEGIN
time_counter :	
	PROCESS (clk, clr_n) BEGIN
		IF (clr_n = '0') THEN
			time_cnt <= (OTHERS => '0');
		ELSE
			IF (clk'EVENT AND clk = '1') THEN
				time_cnt <= time_cnt + '1';
			END IF;
		END IF;
	END PROCESS;

shift_reg :			
	PROCESS (clk, clr_n) BEGIN
		IF (clr_n = '0') THEN
			sht_reg <= "0000";
		ELSE
			IF (clk'EVENT AND clk = '1') THEN
				IF (sht_reg = "1000") THEN
					sht_reg <= (OTHERS => '0');
				ELSE
					IF ( time_cnt = "11111111111111111111" ) THEN
						sht_reg <= (sht_reg (2 DOWNTO 0) & button);
					END IF;
				END IF;
			END IF;
		END IF;
	END PROCESS;

sw_toggle :
	PROCESS (clk, clr_n) BEGIN
		IF (clr_n = '0') THEN
			sw_reg <= '0';
		ELSE
			IF (clk'EVENT AND clk = '1') THEN
				IF (sht_reg = "1000") THEN
					sw_reg <= NOT sw_reg;
				END IF;
			END IF;
		END IF;
	END PROCESS;

	sw_out <= sw_reg;
	
END rtl;