LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY modelsim_lib;
USE modelsim_lib.util.all;

ENTITY fpga_top_sim IS

END fpga_top_sim;

ARCHITECTURE rtl OF fpga_top_sim IS

	CONSTANT	cycle 	: TIME	:= 20 ns;
	CONSTANT	half	: TIME	:= 10 ns;

	SIGNAL	CLOCK_50	:	STD_LOGIC;
	SIGNAL	CLR			:	STD_LOGIC;
	SIGNAL	BUTTON		:	STD_LOGIC;
	SIGNAL	LED			:	STD_LOGIC_VECTOR (3 DOWNTO 0);

SIGNAL moni : std_logic_vector (31 DOWNTO 0);

	COMPONENT fpga_top 
		PORT
		(
			clock_50	:	IN  STD_LOGIC;
			clr			:	IN  STD_LOGIC;
			button		:	IN  STD_LOGIC;
			led			:	OUT  STD_LOGIC_VECTOR(3 DOWNTO 0)
		);
	END COMPONENT;

BEGIN

	u1 : fpga_top
		PORT MAP (
			clock_50 => CLOCK_50,
			clr => CLR,
			button => BUTTON,
			led => LED
			);

	CLK : PROCESS BEGIN
		CLOCK_50 <= '0';
		WAIT FOR half;
		CLOCK_50 <= '1';
		WAIT FOR half;
	END PROCESS CLK;
	
	RESET : PROCESS BEGIN
		CLR <= '1';
		WAIT FOR 115 us;
		CLR <= '0';
		WAIT FOR cycle * 30000;
		CLR <= '1';
		WAIT;
	END PROCESS RESET;
	
	SW : PROCESS BEGIN
		BUTTON <= '1';
		WAIT FOR cycle * 10000000;
		BUTTON <= '0';
		WAIT FOR cycle * 5000000;
	END PROCESS SW;

	MONITOR : PROCESS BEGIN
		init_signal_spy ("/fpga_top_sim/u1/inst2/cnt_out", "/fpga_top_sim/moni", 0);
	WAIT;
	END PROCESS MONITOR;
	
END rtl;