LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY mux_zero IS
	PORT (
		clk		:	IN STD_LOGIC;
		clr_n	:	IN STD_LOGIC;
		sel		:	IN STD_LOGIC;
		data_0	:	IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		data_1	:	IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		dout	:	OUT STD_LOGIC_VECTOR (3 DOWNTO 0):= (OTHERS => '0')
	);
END mux_zero;

ARCHITECTURE rtl OF mux_zero IS

BEGIN
	PROCESS (clk, clr_n) BEGIN
	IF (clr_n = '0') THEN
		dout <= (OTHERS => '0');
	ELSIF (clk'EVENT AND clk = '1') THEN
		IF (sel = '1') THEN
			dout <= data_1;
		ELSE
			dout <= data_0;
		END IF;
	END IF;
	END PROCESS;
	
END rtl;
	